
module Common.EP where

import Common.Util

data EP a b = EP { from :: a -> b, to :: b -> a }

epFun epA epB = EP  { from  = \f -> from epB . f . to epA
		    , to    = \g -> to epB . g . from epA
		    }

--epList epA = EP (map $ from epA) (map $ to epA)

epId  = EP id id

epSum epA epB = EP { from  = from epA -+- from epB
		    , to    = to epA -+- to epB
		    }

epProd epA epB	= EP	{ from	= from epA -*- from epB
			, to	= to epA -*- to epB
			}

epUnit = EP (const ()) (const ())

epCompose :: EP a b -> EP b c -> EP a c
epCompose epAB epBC = EP (from epBC . from epAB) (to epAB . to epBC)

epEP :: EP a a' -> EP b b' -> EP (EP a b) (EP a' b')
epEP epA epB = EP f t
    where
	ab		= epFun epA epB
	ba		= epFun epB epA
	f (EP fa ta)	= EP (from ab fa) (from ba ta)
	t (EP fa' ta')	= EP (to ab fa') (to ba ta')

