
module GenericHaskell.EP where

import Language.Haskell.THSyntax

import GenericHaskell.GH
import Common.EP

_EP :: KindIndexedType
_EP = kindIndexedType 2 0 $
	\[t1,t2] -> ConT "EP" @@ t1 @@ t2

epType :: GenericType
epType k t = _EP k [t,t]

ep :: GenericFun
ep = ep' []
    where
	ep' :: GenericFun'
	ep' env t = case t of
	    Sum	    -> [| epSum |]
	    Prod    -> [| epProd |]
	    Unit    -> [| epUnit |]
	    Arrow   -> [| epFun |]
	    _	    -> defaultTrans "ep" ep' env

epG :: Generic
epG = ("ep", epType, ep)

