{-# OPTIONS -fth #-}

module PolyP.Pmap where

import Common.Util
import PolyP.PolyP

import Language.Haskell.THSyntax

-- Generic Function Definitions -------------------------------------------

fmap2 :: Code -> Q Exp
fmap2 f =
    [| \p r -> $(
	    case f of
		g :+: h	-> [| $(fmap2 g) p r -+- $(fmap2 h) p r |]
		g :*: h	-> [| $(fmap2 g) p r -*- $(fmap2 h) p r |]
		Unit	-> [| const () |]
		Par	-> [| p |]
		Rec	-> [| r |]
		d :@: g	-> [| $(pmap d) ($(fmap2 g) p r) |]
		Const t	-> [| id |]
	)
    |]

pmap :: Regular -> Q Exp
pmap d =
    [|	let pmap_d f = $(inn d)
			. $(fmap2 $ functorOf d) f (pmap_d f)
			. $(out d)
	in pmap_d
    |]

